﻿using Syncfusion.ReportWriter;
using Syncfusion.UI.Xaml.Reports;
using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.Globalization;
using Windows.Storage;
using Windows.Storage.Pickers;
using Windows.Storage.Streams;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x409

namespace UWPwriterSample
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
            ApplicationLanguages.PrimaryLanguageOverride = "fr-fr";
        }

        //async void Button_Click(object sender, RoutedEventArgs e)
        //{
        //    FileSavePicker fileSavePicker = new FileSavePicker();
        //    WriterFormat format = WriterFormat.PDF;

        //    if (pdf.IsChecked == true)
        //    {
        //        fileSavePicker.FileTypeChoices.Add("PDF", new List<string> { ".pdf" });
        //        fileSavePicker.DefaultFileExtension = ".pdf";
        //        format = WriterFormat.PDF;
        //    }
        //    else if (excel.IsChecked == true)
        //    {
        //        fileSavePicker.FileTypeChoices.Add("Excel", new List<string> { ".xls" });
        //        fileSavePicker.DefaultFileExtension = ".xls";
        //        format = WriterFormat.Excel;
        //    }
        //    else if (word.IsChecked == true)
        //    {
        //        fileSavePicker.FileTypeChoices.Add("Word", new List<string> { ".doc" });
        //        fileSavePicker.DefaultFileExtension = ".doc";
        //        format = WriterFormat.Word;
        //    }
        //    else if (html.IsChecked == true)
        //    {
        //        fileSavePicker.FileTypeChoices.Add("Html", new List<string> { ".html" });
        //        fileSavePicker.DefaultFileExtension = ".html";
        //        format = WriterFormat.HTML;
        //    }

        //    fileSavePicker.SuggestedFileName = "ExportReport";
        //    var savedItem = await fileSavePicker.PickSaveFileAsync();

        //    if (savedItem != null)
        //    {
        //        MemoryStream exportFileStream = new MemoryStream();
        //        Assembly assembly = typeof(MainPage).GetTypeInfo().Assembly;
        //        Stream reportStream = assembly.GetManifestResourceStream("UWPwriterSample.Assets.GroupingAgg.rdlc");
        //        ReportDataSourceCollection datas = new ReportDataSourceCollection();
        //        datas.Add(new ReportDataSource { Name = "Sales", Value = SalesDetails.GetData() });

        //        ReportWriter writer = new ReportWriter(reportStream, datas);
        //        writer.PDFFonts = new Dictionary<string, Stream>(StringComparer.OrdinalIgnoreCase);
        //        writer.PDFFonts.Add("Arial Unicode MS", assembly.GetManifestResourceStream("UWPwriterSample.Assets.ARIALUNI.TTF"));
        //        writer.ExportMode = Syncfusion.ReportWriter.ExportMode.Local;
        //        writer.ExportCompleted += Writer_ExportCompleted;
        //        writer.Save(exportFileStream, format);

        //        try
        //        {
        //            using (IRandomAccessStream stream = await savedItem.OpenAsync(FileAccessMode.ReadWrite))
        //            {
        //                // Write compressed data from memory to file
        //                using (Stream outstream = stream.AsStreamForWrite())
        //                {
        //                    byte[] buffer = exportFileStream.ToArray();
        //                    outstream.Write(buffer, 0, buffer.Length);
        //                    outstream.Flush();
        //                }
        //            }
        //            exportFileStream.Dispose();
        //        }
        //        catch { }
        //    }
        //}

        private async void Button_Click(object sender, RoutedEventArgs e)
        {
            FileSavePicker fileSavePicker = new FileSavePicker();
            WriterFormat format = WriterFormat.PDF;

            if (pdf.IsChecked == true)
            {
                fileSavePicker.FileTypeChoices.Add("PDF", new List<string> { ".pdf" });
                fileSavePicker.DefaultFileExtension = ".pdf";
                format = WriterFormat.PDF;
            }
            else if (excel.IsChecked == true)
            {
                fileSavePicker.FileTypeChoices.Add("Excel", new List<string> { ".xls" });
                fileSavePicker.DefaultFileExtension = ".xls";
                format = WriterFormat.Excel;
            }
            else if (word.IsChecked == true)
            {
                fileSavePicker.FileTypeChoices.Add("Word", new List<string> { ".doc" });
                fileSavePicker.DefaultFileExtension = ".doc";
                format = WriterFormat.Word;
            }
            else if (html.IsChecked == true)
            {
                fileSavePicker.FileTypeChoices.Add("Html", new List<string> { ".html" });
                fileSavePicker.DefaultFileExtension = ".html";
                format = WriterFormat.HTML;
            }

            fileSavePicker.SuggestedFileName = "ExportReport";
            var savedItem = await fileSavePicker.PickSaveFileAsync();

            if (savedItem != null)
            {
                MemoryStream exportFileStream = new MemoryStream();
                Assembly assembly = typeof(MainPage).GetTypeInfo().Assembly;
                Stream reportStream = assembly.GetManifestResourceStream("UWPwriterSample.Assets.OrderReport.rdlc");
                //string reportpath = @"../../Assets/Export.rdl";

                //ReportDataSourceCollection datas = new ReportDataSourceCollection();
                //datas.Add(new ReportDataSource { Name = "Sales", Value = SalesDetails.GetData() });

                var Address = new List<AddressObjectValue>
                {
                    new AddressObjectValue(
                    "EUROPE",
                    "Adresse Ligne 1",
                    "01234",
                    "VILLE",
                    "FRANCE")
                };

                // Get the current account
                var orderInformation = new List<OrderInformationObjectValue>
                {
                    new OrderInformationObjectValue(
                        "orderNumber", // TODO : orderNumber
                        "this.CurrentAccount.Name",
                        "deliveryAddress",
                        "ZipCode",
                        "City",
                        "this.CurrentAccount.Name",
                        "orderAddress",
                        "Name",
                        "City",
                        "clientAccount",
                        "reference",
                        "owner.Name",
                        "owner.Phone",
                        "ownerMobilePhone", // TODO :
                        "owner.Fax",
                        "owner.Email",
                        DateTime.Now,
                        "settlementMethod",
                         (decimal)400.6,
                        0, // TODO : transportCosts
                         (decimal)415.6
                        )
                };

                var reportOrderDetail = new List<OrderDetailObjectValue>
                                            {
                                                new OrderDetailObjectValue(
                                                    "Reference",
                                                    "EANCode",
                                                    "Designation",
                                                    "Conditioning",
                                                    "C",
                                                    10,
                                                    (decimal)4.6,
                                                    (decimal)5.6)
                                            };

                var datas = new ReportDataSourceCollection
                {
                    new ReportDataSource { Name = "Address", Value = Address },
                    new ReportDataSource { Name = "OrderInformation", Value = orderInformation },
                    new ReportDataSource { Name = "OrderDetail", Value = reportOrderDetail }
                };


                ReportWriter writer = new ReportWriter(reportStream, datas);
                writer.PDFFonts = new Dictionary<string, Stream>(StringComparer.OrdinalIgnoreCase);
                writer.PDFFonts.Add("Arial Unicode MS", assembly.GetManifestResourceStream("UWPwriterSample.Assets.ARIALUNI.TTF"));
                writer.PDFFonts.Add("Segoe UI", assembly.GetManifestResourceStream("UWPwriterSample.Assets.Segoe_UI.ttf"));
                //ReportWriter writer = new ReportWriter(reportpath);
                writer.ExportMode = Syncfusion.ReportWriter.ExportMode.Local;
                writer.ExportCompleted += Writer_ExportCompleted;
                writer.Save(exportFileStream, format);

                try
                {
                    using (IRandomAccessStream stream = await savedItem.OpenAsync(FileAccessMode.ReadWrite))
                    {
                        // Write compressed data from memory to file
                        using (Stream outstream = stream.AsStreamForWrite())
                        {
                            byte[] buffer = exportFileStream.ToArray();
                            outstream.Write(buffer, 0, buffer.Length);
                            outstream.Flush();
                        }
                    }
                    exportFileStream.Dispose();
                }
                catch { }
            }
        }
        private void Writer_ExportCompleted(object sender, byte[] e)
        {
            Windows.UI.Popups.MessageDialog msgDialog = new Windows.UI.Popups.MessageDialog("Report exporting completed successfully");
            msgDialog.ShowAsync();
        }

    }

    public class SalesDetails
    {
        public string ProdCat { get; set; }
        public string SubCat { get; set; }
        public double? OrderYear { get; set; }
        public string OrderQtr { get; set; }
        public double? Sales { get; set; }
        public static IList GetData()
        {
            List<SalesDetails> datas = new List<SalesDetails>();
            SalesDetails data = null;
            data = new SalesDetails()
            {
                ProdCat = "Accessories",
                SubCat = "Helmets",
                OrderYear = 2002,
                OrderQtr = "Q1",
                Sales = 4945.6925
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Components",
                SubCat = "Road Frames",
                OrderYear = 2002,
                OrderQtr = "Q3",
                Sales = 957715.1942
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Components",
                SubCat = "Forks",
                OrderYear = 2002,
                OrderQtr = "Q4",
                Sales = 23543.1060
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Bikes",
                SubCat = "Road Bikes",
                OrderYear = 2002,
                OrderQtr = "Q1",
                Sales = 3171787.6112
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Accessories",
                SubCat = "Helmets",
                OrderYear = 2002,
                OrderQtr = "Q3",
                Sales = 33853.1033
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Components",
                SubCat = "Wheels",
                OrderYear = 2002,
                OrderQtr = "Q4",
                Sales = 163921.8870
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Bikes",
                SubCat = "Road Bikes",
                OrderYear = 2003,
                OrderQtr = "Q2",
                Sales = 4119658.6506
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Clothing",
                SubCat = "Socks",
                OrderYear = 2003,
                OrderQtr = "Q3",
                Sales = 6968.6884
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Bikes",
                SubCat = "Road Bikes",
                OrderYear = 2003,
                OrderQtr = "Q4",
                Sales = 3734891.6389
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Components",
                SubCat = "Mountain Frames",
                OrderYear = 2002,
                OrderQtr = "Q3",
                Sales = 608352.8754
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Components",
                SubCat = "Handlebars",
                OrderYear = 2002,
                OrderQtr = "Q4",
                Sales = 18309.4452
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Components",
                SubCat = "Road Frames",
                OrderYear = 2003,
                OrderQtr = "Q4",
                Sales = 286591.8208
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Accessories",
                SubCat = "Tires and Tubes",
                OrderYear = 2003,
                OrderQtr = "Q3",
                Sales = 41940.3364
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Components",
                SubCat = "Mountain Frames",
                OrderYear = 2003,
                OrderQtr = "Q2",
                Sales = 440260.9831
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Components",
                SubCat = "Road Frames",
                OrderYear = 2003,
                OrderQtr = "Q2",
                Sales = 457688.8401
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Clothing",
                SubCat = "Vests",
                OrderYear = 2003,
                OrderQtr = "Q4",
                Sales = 66882.6450
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Accessories",
                SubCat = "Pumps",
                OrderYear = 2002,
                OrderQtr = "Q4",
                Sales = 3226.3860
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Clothing",
                SubCat = "Tights",
                OrderYear = 2003,
                OrderQtr = "Q2",
                Sales = 51600.6190
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Components",
                SubCat = "Chains",
                OrderYear = 2003,
                OrderQtr = "Q3",
                Sales = 3476.0176
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Components",
                SubCat = "Handlebars",
                OrderYear = 2003,
                OrderQtr = "Q2",
                Sales = 17194.2146
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Components",
                SubCat = "Mountain Frames",
                OrderYear = 2003,
                OrderQtr = "Q4",
                Sales = 565229.8810
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Clothing",
                SubCat = "Tights",
                OrderYear = 2003,
                OrderQtr = "Q4",
                Sales = 243.7175
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Components",
                SubCat = "Road Frames",
                OrderYear = 2002,
                OrderQtr = "Q2",
                Sales = 155311.4063
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Components",
                SubCat = "Mountain Frames",
                OrderYear = 2002,
                OrderQtr = "Q2",
                Sales = 220935.1648
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Accessories",
                SubCat = "Locks",
                OrderYear = 2003,
                OrderQtr = "Q4",
                Sales = 15.0000
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Components",
                SubCat = "Mountain Frames",
                OrderYear = 2003,
                OrderQtr = "Q3",
                Sales = 827287.5234
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Accessories",
                SubCat = "Bike Racks",
                OrderYear = 2003,
                OrderQtr = "Q3",
                Sales = 75920.4000
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Components",
                SubCat = "Bottom Brackets",
                OrderYear = 2003,
                OrderQtr = "Q3",
                Sales = 17453.6400
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Bikes",
                SubCat = "Touring Bikes",
                OrderYear = 2003,
                OrderQtr = "Q3",
                Sales = 3298006.2858
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Components",
                SubCat = "Brakes",
                OrderYear = 2003,
                OrderQtr = "Q4",
                Sales = 18571.4700
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Clothing",
                SubCat = "Tights",
                OrderYear = 2002,
                OrderQtr = "Q4",
                Sales = 56782.4280
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Components",
                SubCat = "Pedals",
                OrderYear = 2003,
                OrderQtr = "Q3",
                Sales = 54185.2014
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Clothing",
                SubCat = "Jerseys",
                OrderYear = 2003,
                OrderQtr = "Q3",
                Sales = 173041.0492
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Clothing",
                SubCat = "Jerseys",
                OrderYear = 2002,
                OrderQtr = "Q2",
                Sales = 16931.2362
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Components",
                SubCat = "Headsets",
                OrderYear = 2002,
                OrderQtr = "Q3",
                Sales = 19701.9001
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Components",
                SubCat = "Road Frames",
                OrderYear = 2002,
                OrderQtr = "Q4",
                Sales = 458089.4246
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Clothing",
                SubCat = "Shorts",
                OrderYear = 2003,
                OrderQtr = "Q1",
                Sales = 11230.1280
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Bikes",
                SubCat = "Road Bikes",
                OrderYear = 2002,
                OrderQtr = "Q4",
                Sales = 4189621.8590
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Components",
                SubCat = "Brakes",
                OrderYear = 2003,
                OrderQtr = "Q3",
                Sales = 26659.0800
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Components",
                SubCat = "Wheels",
                OrderYear = 2003,
                OrderQtr = "Q4",
                Sales = 83.2981
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Clothing",
                SubCat = "Vests",
                OrderYear = 2003,
                OrderQtr = "Q3",
                Sales = 81085.6900
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Components",
                SubCat = "Cranksets",
                OrderYear = 2003,
                OrderQtr = "Q3",
                Sales = 80244.1372
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Clothing",
                SubCat = "Socks",
                OrderYear = 2003,
                OrderQtr = "Q4",
                Sales = 6183.1422
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Components",
                SubCat = "Wheels",
                OrderYear = 2003,
                OrderQtr = "Q2",
                Sales = 163929.9435
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Clothing",
                SubCat = "Tights",
                OrderYear = 2002,
                OrderQtr = "Q3",
                Sales = 67088.3037
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Clothing",
                SubCat = "Tights",
                OrderYear = 2003,
                OrderQtr = "Q3",
                Sales = 779.8960
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Clothing",
                SubCat = "Socks",
                OrderYear = 2002,
                OrderQtr = "Q1",
                Sales = 1273.8550
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Bikes",
                SubCat = "Road Bikes",
                OrderYear = 2002,
                OrderQtr = "Q3",
                Sales = 4930692.7825
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Clothing",
                SubCat = "Shorts",
                OrderYear = 2003,
                OrderQtr = "Q4",
                Sales = 84192.3708
            };
            datas.Add(data);
            data = new SalesDetails()
            {
                ProdCat = "Clothing",
                SubCat = "Jerseys",
                OrderYear = 2002,
                OrderQtr = "Q3",
                Sales = 48901.7598
            };
            datas.Add(data);
            return datas;
        }
    }

    public class AddressObjectValue
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="AddressObjectValue" /> class.
        /// </summary>
        /// <param name="name">The name.</param>
        /// <param name="address">The address.</param>
        /// <param name="zipCode">The zip code.</param>
        /// <param name="city">The city.</param>
        /// <param name="country">The country.</param>
        public AddressObjectValue(
            string name,
            string address,
            string zipCode,
            string city,
            string country)
        {
            this.Name = name;
            this.Address = address;
            this.ZipCode = zipCode;
            this.City = city;
            this.Country = country;
        }

        /// <summary>
        /// Gets the name.
        /// </summary>
        /// <value>
        /// The name.
        /// </value>
        public string Name { get; }

        /// <summary>
        /// Gets the address.
        /// </summary>
        /// <value>
        /// The address.
        /// </value>
        public string Address { get; }

        /// <summary>
        /// Gets the zip code.
        /// </summary>
        /// <value>
        /// The zip code.
        /// </value>
        public string ZipCode { get; }

        /// <summary>
        /// Gets the city.
        /// </summary>
        /// <value>
        /// The city.
        /// </value>
        public string City { get; }

        /// <summary>
        /// Gets the country.
        /// </summary>
        /// <value>
        /// The country.
        /// </value>
        public string Country { get; }
    }

    public class OrderDetailObjectValue
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="OrderDetailObjectValue"/> class.
        /// </summary>
        /// <param name="reference">The reference.</param>
        /// <param name="eanCode">The EAN code.</param>
        /// <param name="designation">The designation.</param>
        /// <param name="conditioning">The conditioning.</param>
        /// <param name="category">The category.</param>
        /// <param name="orderedQuantity">The ordered quantity.</param>
        /// <param name="priceWithoutTax">The price without tax.</param>
        /// <param name="totalWithoutTax">The total without tax.</param>
        public OrderDetailObjectValue(
            string reference,
            string eanCode,
            string designation,
            string conditioning,
            string category,
            int orderedQuantity,
            decimal priceWithoutTax,
            decimal totalWithoutTax)
        {
            this.Reference = reference;
            this.EANCode = eanCode;
            this.Designation = designation;
            this.Conditioning = conditioning;
            this.Category = category;
            this.OrderedQuantity = orderedQuantity;
            this.PriceWithoutTax = priceWithoutTax;
            this.TotalWithoutTax = totalWithoutTax;
        }

        /// <summary>
        /// Gets the reference.
        /// </summary>
        /// <value>
        /// The reference.
        /// </value>
        public string Reference { get; }

        /// <summary>
        /// Gets the EAN code.
        /// </summary>
        /// <value>
        /// The EAN code.
        /// </value>
        public string EANCode { get; }

        /// <summary>
        /// Gets the designation.
        /// </summary>
        /// <value>
        /// The designation.
        /// </value>
        public string Designation { get; }

        /// <summary>
        /// Gets the conditioning.
        /// </summary>
        /// <value>
        /// The conditioning.
        /// </value>
        public string Conditioning { get; }

        /// <summary>
        /// Gets the category.
        /// </summary>
        /// <value>
        /// The category.
        /// </value>
        public string Category { get; }

        /// <summary>
        /// Gets the ordered quantity.
        /// </summary>
        /// <value>
        /// The ordered quantity.
        /// </value>
        public int OrderedQuantity { get; }

        /// <summary>
        /// Gets the price without tax.
        /// </summary>
        /// <value>
        /// The price without tax.
        /// </value>
        public decimal PriceWithoutTax { get; }

        /// <summary>
        /// Gets the total without tax.
        /// </summary>
        /// <value>
        /// The total without tax.
        /// </value>
        public decimal TotalWithoutTax { get; }
    }

    public class OrderInformationObjectValue
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="OrderInformationObjectValue" /> class.
        /// </summary>
        /// <param name="orderNumber">The order number.</param>
        /// <param name="deliveryAccountName">Name of the delivery account.</param>
        /// <param name="deliveryAddress">The delivery address.</param>
        /// <param name="deliveryZipCode">The delivery zip code.</param>
        /// <param name="deliveryCity">The delivery City.</param>
        /// <param name="orderAccountName">Name of the order account.</param>
        /// <param name="orderAddress">The order address.</param>
        /// <param name="orderZipCode">The order zip code.</param>
        /// <param name="orderCity">The order City.</param>
        /// <param name="clientAccount">The client account.</param>
        /// <param name="reference">The reference.</param>
        /// <param name="owner">The owner.</param>
        /// <param name="ownerPhone">The owner phone.</param>
        /// <param name="ownerMobilePhone">The owner mobile phone.</param>
        /// <param name="ownerFax">The owner fax.</param>
        /// <param name="ownerEmail">The owner email.</param>
        /// <param name="documentDate">The document date.</param>
        /// <param name="settlementMethod">The settlement method.</param>
        /// <param name="productWithoutTax">The product without tax.</param>
        /// <param name="transportCosts">The transport costs.</param>
        /// <param name="totalAllTaxesIncluded">The total all taxes included.</param>
        public OrderInformationObjectValue(
            string orderNumber,
            string deliveryAccountName,
            string deliveryAddress,
            string deliveryZipCode,
            string deliveryCity,
            string orderAccountName,
            string orderAddress,
            string orderZipCode,
            string orderCity,
            string clientAccount,
            string reference,
            string owner,
            string ownerPhone,
            string ownerMobilePhone,
            string ownerFax,
            string ownerEmail,
            DateTime documentDate,
            string settlementMethod,
            decimal productWithoutTax,
            decimal transportCosts,
            decimal totalAllTaxesIncluded)
        {
            this.OrderNumber = orderNumber;
            this.DeliveryAccountName = deliveryAccountName;
            this.DeliveryAddress = deliveryAddress;
            this.DeliveryZipCode = deliveryZipCode;
            this.DeliveryCity = deliveryCity;
            this.OrderAccountName = orderAccountName;
            this.OrderAddress = orderAddress;
            this.OrderZipCode = orderZipCode;
            this.OrderCity = orderCity;
            this.ClientAccount = clientAccount;
            this.Reference = reference;
            this.Owner = owner;
            this.OwnerPhone = ownerPhone;
            this.OwnerMobilePhone = ownerMobilePhone;
            this.OwnerFax = ownerFax;
            this.OwnerEmail = ownerEmail;
            this.DocumentDate = documentDate;
            this.SettlementMethod = settlementMethod;
            this.ProductWithoutTax = productWithoutTax;
            this.TransportCosts = transportCosts;
            this.TotalAllTaxesIncluded = totalAllTaxesIncluded;
        }

        /// <summary>
        /// Gets the order number.
        /// </summary>
        /// <value>
        /// The order number.
        /// </value>
        public string OrderNumber { get; }

        /// <summary>
        /// Gets the name of the delivery account.
        /// </summary>
        /// <value>
        /// The name of the delivery account.
        /// </value>
        public string DeliveryAccountName { get; }

        /// <summary>
        /// Gets the delivery address.
        /// </summary>
        /// <value>
        /// The delivery address.
        /// </value>
        public string DeliveryAddress { get; }

        /// <summary>
        /// Gets the delivery zip code.
        /// </summary>
        /// <value>
        /// The delivery zip code.
        /// </value>
        public string DeliveryZipCode { get; }

        /// <summary>
        /// Gets the delivery City.
        /// </summary>
        /// <value>
        /// The delivery City.
        /// </value>
        public string DeliveryCity { get; }

        /// <summary>
        /// Gets the name of the order account.
        /// </summary>
        /// <value>
        /// The name of the order account.
        /// </value>
        public string OrderAccountName { get; }

        /// <summary>
        /// Gets the order address.
        /// </summary>
        /// <value>
        /// The order address.
        /// </value>
        public string OrderAddress { get; }

        /// <summary>
        /// Gets the order zip code.
        /// </summary>
        /// <value>
        /// The order zip code.
        /// </value>
        public string OrderZipCode { get; }

        /// <summary>
        /// Gets the order City.
        /// </summary>
        /// <value>
        /// The order City.
        /// </value>
        public string OrderCity { get; }

        /// <summary>
        /// Gets the client account.
        /// </summary>
        /// <value>
        /// The client account.
        /// </value>
        public string ClientAccount { get; }

        /// <summary>
        /// Gets the reference.
        /// </summary>
        /// <value>
        /// The reference.
        /// </value>
        public string Reference { get; }

        /// <summary>
        /// Gets the owner.
        /// </summary>
        /// <value>
        /// The owner.
        /// </value>
        public string Owner { get; }

        /// <summary>
        /// Gets the owner phone.
        /// </summary>
        /// <value>
        /// The owner phone.
        /// </value>
        public string OwnerPhone { get; }

        /// <summary>
        /// Gets the owner mobile phone.
        /// </summary>
        /// <value>
        /// The owner mobile phone.
        /// </value>
        public string OwnerMobilePhone { get; }

        /// <summary>
        /// Gets the owner fax.
        /// </summary>
        /// <value>
        /// The owner fax.
        /// </value>
        public string OwnerFax { get; }

        /// <summary>
        /// Gets the owner email.
        /// </summary>
        /// <value>
        /// The owner email.
        /// </value>
        public string OwnerEmail { get; }

        /// <summary>
        /// Gets the document date.
        /// </summary>
        /// <value>
        /// The document date.
        /// </value>
        public DateTime DocumentDate { get; }

        /// <summary>
        /// Gets the settlement method.
        /// </summary>
        /// <value>
        /// The settlement method.
        /// </value>
        public string SettlementMethod { get; }

        /// <summary>
        /// Gets the product without tax.
        /// </summary>
        /// <value>
        /// The product without tax.
        /// </value>
        public decimal ProductWithoutTax { get; }

        /// <summary>
        /// Gets the transport costs.
        /// </summary>
        /// <value>
        /// The transport costs.
        /// </value>
        public decimal TransportCosts { get; }

        /// <summary>
        /// Gets the total all taxes included.
        /// </summary>
        /// <value>
        /// The total all taxes included.
        /// </value>
        public decimal TotalAllTaxesIncluded { get; }
    }

}
